Index: /branches/HeuristicLab.DebugEngine/DebugEngine.cs
===================================================================
--- /branches/HeuristicLab.DebugEngine/DebugEngine.cs	(revision 4903)
+++ /branches/HeuristicLab.DebugEngine/DebugEngine.cs	(revision 4904)
@@ -21,4 +21,5 @@
 
 using System;
+using System.Collections.Generic;
 using System.Linq;
 using System.Threading;
@@ -48,4 +49,6 @@
       Log = cloner.Clone(original.Log);
       ExecutionStack = cloner.Clone(original.ExecutionStack);
+      OperatorTrace = new ItemList<IOperator>(original.OperatorTrace.Select(op => cloner.Clone(op)));
+      operatorParents = original.operatorParents.ToDictionary(kvp => cloner.Clone(kvp.Key), kvp => cloner.Clone(kvp.Value));
       pausePending = original.pausePending;
       stopPending = original.stopPending;
@@ -60,4 +63,6 @@
       Log = new Log();
       ExecutionStack = new ExecutionStack();
+      OperatorTrace = new ItemList<IOperator>();
+      operatorParents = new Dictionary<IAtomicOperation, IAtomicOperation>();
       pausePending = stopPending = false;
       timer = new System.Timers.Timer(100);
@@ -110,4 +115,10 @@
     }
 
+    [Storable]
+    public ItemList<IOperator> OperatorTrace { get; private set; }
+
+    [Storable]
+    private Dictionary<IAtomicOperation, IAtomicOperation> operatorParents;
+
     #endregion
 
@@ -131,4 +142,6 @@
       ignoreNextBreakpoint = false;
       CurrentOperation = null;
+      OperatorTrace.Clear();
+      operatorParents.Clear();
       OnPrepared();
     }
@@ -140,4 +153,6 @@
       ignoreNextBreakpoint = false;
       CurrentOperation = null;
+      OperatorTrace.Clear();
+      operatorParents.Clear();
       OnPrepared();
     }
@@ -161,5 +176,4 @@
     public override void Start() {
       base.Start();
-      CurrentOperation = null;
       ThreadPool.QueueUserWorkItem(new WaitCallback(Run), null);
     }
@@ -250,5 +264,5 @@
           ExpandOperationCollection(operations);
         } else if (ExecutionStack.Count > 0) {
-          Log.LogMessage("Poping execution stack");
+          Log.LogMessage("Popping execution stack");
           CurrentOperation = ExecutionStack.Last();
           ExecutionStack.RemoveAt(ExecutionStack.Count - 1);
@@ -256,6 +270,23 @@
           Log.LogMessage("Nothing to do");
         }
+        GenerateOperationTrace();
       } catch (Exception x) {
         OnExceptionOccurred(x);
+      }
+    }
+
+    private void GenerateOperationTrace() {
+      var operation = CurrentOperation as IAtomicOperation;
+      if (operation != null) {
+        List<IOperator> trace = new List<IOperator>();
+        while (operation != null) {
+          trace.Add(operation.Operator);
+          IAtomicOperation parent = null;
+          operatorParents.TryGetValue(operation, out parent);
+          operation = parent;
+        }
+        trace.Reverse();
+        OperatorTrace.Clear();
+        OperatorTrace.AddRange(trace);
       }
     }
@@ -276,9 +307,10 @@
           currentOperator = operation.Operator;
           IOperation successor = operation.Operator.Execute((IExecutionContext)operation);
-          CurrentOperation = null;
-          currentOperator = null;
           if (successor != null) {
+            AssignParents(operation, successor);
             ExecutionStack.Add(successor);
           }
+          currentOperator = null;
+          CurrentOperation = null;
         } catch (Exception ex) {
           OnExceptionOccurred(new OperatorExecutionException(operation.Operator, ex));
@@ -288,4 +320,14 @@
     }
 
+    private void AssignParents(IAtomicOperation parent, IOperation successor) {
+      OperationCollection operations = successor as OperationCollection;
+      if (operations != null)
+        foreach (var op in operations)
+          AssignParents(parent, op);
+      IAtomicOperation atomicOperation = successor as IAtomicOperation;
+      if (atomicOperation != null && atomicOperation.Operator != null && !operatorParents.ContainsKey(atomicOperation))
+        operatorParents[atomicOperation] = parent;
+    }
+
     protected virtual void ExpandOperationCollection(OperationCollection operations) {
       ExecutionStack.AddRange(operations.Reverse());
Index: /branches/HeuristicLab.DebugEngine/DebugEngineView.Designer.cs
===================================================================
--- /branches/HeuristicLab.DebugEngine/DebugEngineView.Designer.cs	(revision 4903)
+++ /branches/HeuristicLab.DebugEngine/DebugEngineView.Designer.cs	(revision 4904)
@@ -49,6 +49,5 @@
       this.label1 = new System.Windows.Forms.Label();
       this.executionTimeTextBox = new System.Windows.Forms.TextBox();
-      this.executionStackView = new HeuristicLab.DebugEngine.ExecutionStackView();
-      this.operationContentView = new HeuristicLab.DebugEngine.OperationContentView();
+      this.operationContentView = new OperationContentView();
       this.logView = new HeuristicLab.Core.Views.LogView();
       this.splitContainer1 = new System.Windows.Forms.SplitContainer();
@@ -58,4 +57,7 @@
       this.refreshButton = new System.Windows.Forms.Button();
       this.skipStackOpsCheckBox = new System.Windows.Forms.CheckBox();
+      this.splitContainer3 = new System.Windows.Forms.SplitContainer();
+      this.executionStackView = new HeuristicLab.DebugEngine.ExecutionStackView();
+      this.operatorTraceView = new OperatorTraceView();
       this.splitContainer1.Panel1.SuspendLayout();
       this.splitContainer1.Panel2.SuspendLayout();
@@ -64,4 +66,6 @@
       this.splitContainer2.Panel2.SuspendLayout();
       this.splitContainer2.SuspendLayout();
+      this.splitContainer3.Panel1.SuspendLayout();
+      this.splitContainer3.SuspendLayout();
       this.SuspendLayout();
       // 
@@ -85,26 +89,4 @@
       this.executionTimeTextBox.TabIndex = 1;
       // 
-      // executionStackView
-      // 
-      this.executionStackView.Caption = "Execution Stack View";
-      this.executionStackView.Content = null;
-      this.executionStackView.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.executionStackView.Location = new System.Drawing.Point(0, 0);
-      this.executionStackView.Name = "executionStackView";
-      this.executionStackView.ReadOnly = false;
-      this.executionStackView.Size = new System.Drawing.Size(252, 262);
-      this.executionStackView.TabIndex = 0;
-      // 
-      // operationContentView
-      // 
-      this.operationContentView.Caption = "Operation Content View";
-      this.operationContentView.Content = null;
-      this.operationContentView.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.operationContentView.Location = new System.Drawing.Point(0, 0);
-      this.operationContentView.Name = "operationContentView";
-      this.operationContentView.ReadOnly = false;
-      this.operationContentView.Size = new System.Drawing.Size(610, 503);
-      this.operationContentView.TabIndex = 0;
-      // 
       // logView
       // 
@@ -115,5 +97,5 @@
       this.logView.Name = "logView";
       this.logView.ReadOnly = false;
-      this.logView.Size = new System.Drawing.Size(252, 237);
+      this.logView.Size = new System.Drawing.Size(198, 237);
       this.logView.TabIndex = 2;
       // 
@@ -132,14 +114,12 @@
       // 
       this.splitContainer1.Panel2.Controls.Add(this.logView);
-      this.splitContainer1.Size = new System.Drawing.Size(252, 503);
-      this.splitContainer1.SplitterDistance = 262;
+      this.splitContainer1.Size = new System.Drawing.Size(198, 502);
+      this.splitContainer1.SplitterDistance = 261;
       this.splitContainer1.TabIndex = 3;
       // 
       // splitContainer2
       // 
-      this.splitContainer2.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-                  | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.splitContainer2.Location = new System.Drawing.Point(3, 32);
+      this.splitContainer2.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.splitContainer2.Location = new System.Drawing.Point(0, 0);
       this.splitContainer2.Name = "splitContainer2";
       // 
@@ -151,6 +131,6 @@
       // 
       this.splitContainer2.Panel2.Controls.Add(this.operationContentView);
-      this.splitContainer2.Size = new System.Drawing.Size(866, 503);
-      this.splitContainer2.SplitterDistance = 252;
+      this.splitContainer2.Size = new System.Drawing.Size(683, 502);
+      this.splitContainer2.SplitterDistance = 198;
       this.splitContainer2.TabIndex = 0;
       // 
@@ -189,10 +169,49 @@
       this.skipStackOpsCheckBox.UseVisualStyleBackColor = true;
       // 
+      // splitContainer3
+      // 
+      this.splitContainer3.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.splitContainer3.Location = new System.Drawing.Point(3, 33);
+      this.splitContainer3.Name = "splitContainer3";
+      // 
+      // splitContainer3.Panel1
+      // 
+      this.splitContainer3.Panel1.Controls.Add(this.splitContainer2);
+      this.splitContainer3.Panel2.Controls.Add(this.operatorTraceView);
+      this.splitContainer3.Size = new System.Drawing.Size(866, 502);
+      this.splitContainer3.SplitterDistance = 683;
+      this.splitContainer3.TabIndex = 7;
+      this.operatorTraceView.Dock = System.Windows.Forms.DockStyle.Fill;
+      // 
+      // executionStackView
+      // 
+      this.executionStackView.Caption = "Execution Stack View";
+      this.executionStackView.Content = null;
+      this.executionStackView.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.executionStackView.Location = new System.Drawing.Point(0, 0);
+      this.executionStackView.Name = "executionStackView";
+      this.executionStackView.ReadOnly = false;
+      this.executionStackView.Size = new System.Drawing.Size(198, 261);
+      this.executionStackView.TabIndex = 0;
+      // 
+      // operationContentView
+      // 
+      this.operationContentView.Caption = "Operation Content View";
+      this.operationContentView.Content = null;
+      this.operationContentView.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.operationContentView.Location = new System.Drawing.Point(0, 0);
+      this.operationContentView.Name = "operationContentView";
+      this.operationContentView.ReadOnly = false;
+      this.operationContentView.Size = new System.Drawing.Size(481, 502);
+      this.operationContentView.TabIndex = 0;
+      // 
       // DebugEngineView
       // 
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.Controls.Add(this.splitContainer3);
       this.Controls.Add(this.skipStackOpsCheckBox);
       this.Controls.Add(this.refreshButton);
-      this.Controls.Add(this.splitContainer2);
       this.Controls.Add(this.stepButton);
       this.Controls.Add(this.executionTimeTextBox);
@@ -206,4 +225,6 @@
       this.splitContainer2.Panel2.ResumeLayout(false);
       this.splitContainer2.ResumeLayout(false);
+      this.splitContainer3.Panel1.ResumeLayout(false);
+      this.splitContainer3.ResumeLayout(false);
       this.ResumeLayout(false);
       this.PerformLayout();
@@ -224,4 +245,6 @@
     private System.Windows.Forms.Button refreshButton;
     private System.Windows.Forms.CheckBox skipStackOpsCheckBox;
+    private System.Windows.Forms.SplitContainer splitContainer3;
+    private OperatorTraceView operatorTraceView;
 
   }
Index: /branches/HeuristicLab.DebugEngine/DebugEngineView.cs
===================================================================
--- /branches/HeuristicLab.DebugEngine/DebugEngineView.cs	(revision 4903)
+++ /branches/HeuristicLab.DebugEngine/DebugEngineView.cs	(revision 4904)
@@ -123,4 +123,5 @@
             executionStackView.SuspendUpdate();
             logView.Content = null;
+            operatorTraceView.Content = null;
             break;
           default:
@@ -128,4 +129,5 @@
             executionStackView.ResumeUpdate();
             operationContentView.Content = new OperationContent(Content.CurrentOperation);
+            operatorTraceView.Content = Content.OperatorTrace;
             break;
         }
@@ -138,6 +140,4 @@
         Invoke(new EventHandler<OperationChangedEventArgs>(Content_CurrentOperationChanged), sender, e);
       } else {
-        if (Content.ExecutionState != ExecutionState.Started)
-          operationContentView.Content = new OperationContent(Content.CurrentOperation);
       }
     }
Index: /branches/HeuristicLab.DebugEngine/DebugEngineView.resx
===================================================================
--- /branches/HeuristicLab.DebugEngine/DebugEngineView.resx	(revision 4903)
+++ /branches/HeuristicLab.DebugEngine/DebugEngineView.resx	(revision 4904)
@@ -122,6 +122,6 @@
     <value>
         iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8
-        YQUAAAAgY0hSTQAAeiYAAICEAAD6AAAAgOgAAHUwAADqYAAAOpgAABdwnLpRPAAAAAlwSFlzAAALCwAA
-        CwsBbQSEtwAAARBJREFUOE9j+P//PwM6Tuh5woxNHJsYhmaQIqABMkDMRIwhWA0onPX8f/zkt0rEGILV
+        YQUAAAAgY0hSTQAAeiYAAICEAAD6AAAAgOgAAHUwAADqYAAAOpgAABdwnLpRPAAAAAlwSFlzAAAK/gAA
+        Cv4B5iV4ZgAAARBJREFUOE9j+P//PwM6Tuh5woxNHJsYhmaQIqABMkDMRIwhWA0onPX8f/zkt0rEGILV
         gNyZz/4ndN/7HzfhtQYh72A1IGPK0//z9v/+H9Rw8zXQAFt8huAKg/+z9/3637n173+30sv/gQbY4zIE
         qwGRXY/+T9n263/J0r//E6b//W+TexanIVgNCGx++L917XuwZuOSL/+lo6/9N45c9t+h6Gw8ukuwGuBR
@@ -137,6 +137,6 @@
     <value>
         iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8
-        YQUAAAAgY0hSTQAAeiYAAICEAAD6AAAAgOgAAHUwAADqYAAAOpgAABdwnLpRPAAAAAlwSFlzAAALEQAA
-        CxEBf2RfkQAAAmFJREFUOE+dk21IU1EYx3cVVzkhaLCy+UaY0xwlZkYRmiGR7oMEUlAGfRGKvkRFVOQ0
+        YQUAAAAgY0hSTQAAeiYAAICEAAD6AAAAgOgAAHUwAADqYAAAOpgAABdwnLpRPAAAAAlwSFlzAAALBAAA
+        CwQBG8oqrQAAAmFJREFUOE+dk21IU1EYx3cVVzkhaLCy+UaY0xwlZkYRmiGR7oMEUlAGfRGKvkRFVOQ0
         DddsVmtbvpQWhCFBSvaCUcRAk0gGm8SGM7JtrU1nzYFvu3P33znDRcLpSxceDvdefr/zv+d5Lidaufjg
         QKKIWwNSUo4Tz4u4RAl5xYsgJIuEcADCYlS8oQKLvvvKdam1n+PcqjUyN5ox7PyIVrMB1U9PoKxThZI7
Index: /branches/HeuristicLab.DebugEngine/ExecutionStackView.Designer.cs
===================================================================
--- /branches/HeuristicLab.DebugEngine/ExecutionStackView.Designer.cs	(revision 4903)
+++ /branches/HeuristicLab.DebugEngine/ExecutionStackView.Designer.cs	(revision 4904)
@@ -65,4 +65,5 @@
     private System.Windows.Forms.TreeView treeView;
     private System.Windows.Forms.GroupBox groupBox;
+
   }
 }
Index: /branches/HeuristicLab.DebugEngine/HeuristicLab.DebugEngine.csproj
===================================================================
--- /branches/HeuristicLab.DebugEngine/HeuristicLab.DebugEngine.csproj	(revision 4903)
+++ /branches/HeuristicLab.DebugEngine/HeuristicLab.DebugEngine.csproj	(revision 4904)
@@ -140,4 +140,10 @@
       <DependentUpon>OperationContentView.cs</DependentUpon>
     </Compile>
+    <Compile Include="OperatorTraceView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="OperatorTraceView.Designer.cs">
+      <DependentUpon>OperatorTraceView.cs</DependentUpon>
+    </Compile>
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="Properties\Resources.Designer.cs">
@@ -157,4 +163,7 @@
     <EmbeddedResource Include="OperationContentView.resx">
       <DependentUpon>OperationContentView.cs</DependentUpon>
+    </EmbeddedResource>
+    <EmbeddedResource Include="OperatorTraceView.resx">
+      <DependentUpon>OperatorTraceView.cs</DependentUpon>
     </EmbeddedResource>
     <EmbeddedResource Include="Properties\Resources.resx">
Index: /branches/HeuristicLab.DebugEngine/OperationContentView.cs
===================================================================
--- /branches/HeuristicLab.DebugEngine/OperationContentView.cs	(revision 4903)
+++ /branches/HeuristicLab.DebugEngine/OperationContentView.cs	(revision 4904)
@@ -197,6 +197,4 @@
     }
 
-    #endregion
-
     private void nameTextBox_DoubleClick(object sender, EventArgs e) {
       if (Content != null && Content.IsAtomic && Content.AtomicOperation.Operator != null)
@@ -204,4 +202,8 @@
     }
 
+    #endregion
+
+
+
   }
 }
Index: /branches/HeuristicLab.DebugEngine/OperatorTraceView.Designer.cs
===================================================================
--- /branches/HeuristicLab.DebugEngine/OperatorTraceView.Designer.cs	(revision 4904)
+++ /branches/HeuristicLab.DebugEngine/OperatorTraceView.Designer.cs	(revision 4904)
@@ -0,0 +1,71 @@
+﻿namespace HeuristicLab.DebugEngine {
+  partial class OperatorTraceView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.operatorTraceGroupBox = new System.Windows.Forms.GroupBox();
+      this.listView = new System.Windows.Forms.ListView();
+      this.operatorTraceGroupBox.SuspendLayout();
+      this.SuspendLayout();
+      // 
+      // operatorTraceGroupBox
+      // 
+      this.operatorTraceGroupBox.Controls.Add(this.listView);
+      this.operatorTraceGroupBox.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.operatorTraceGroupBox.Location = new System.Drawing.Point(0, 0);
+      this.operatorTraceGroupBox.Name = "operatorTraceGroupBox";
+      this.operatorTraceGroupBox.Size = new System.Drawing.Size(515, 405);
+      this.operatorTraceGroupBox.TabIndex = 0;
+      this.operatorTraceGroupBox.TabStop = false;
+      this.operatorTraceGroupBox.Text = "Operator Trace";
+      // 
+      // listView
+      // 
+      this.listView.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.listView.FullRowSelect = true;
+      this.listView.Location = new System.Drawing.Point(3, 16);
+      this.listView.Name = "listView";
+      this.listView.Size = new System.Drawing.Size(509, 386);
+      this.listView.TabIndex = 0;
+      this.listView.UseCompatibleStateImageBehavior = false;
+      this.listView.View = System.Windows.Forms.View.List;
+      this.listView.ItemActivate += new System.EventHandler(this.listView_ItemActivate);
+      // 
+      // OperatorTraceView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.operatorTraceGroupBox);
+      this.Name = "OperatorTraceView";
+      this.Size = new System.Drawing.Size(515, 405);
+      this.operatorTraceGroupBox.ResumeLayout(false);
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.GroupBox operatorTraceGroupBox;
+    private System.Windows.Forms.ListView listView;
+  }
+}
Index: /branches/HeuristicLab.DebugEngine/OperatorTraceView.cs
===================================================================
--- /branches/HeuristicLab.DebugEngine/OperatorTraceView.cs	(revision 4904)
+++ /branches/HeuristicLab.DebugEngine/OperatorTraceView.cs	(revision 4904)
@@ -0,0 +1,81 @@
+﻿using System;
+using System.Windows.Forms;
+using HeuristicLab.Collections;
+using HeuristicLab.Core;
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.DebugEngine {
+
+  [View("Operator Trace View")]
+  [Content(typeof(ItemList<IOperator>), IsDefaultView = true)]
+  public sealed partial class OperatorTraceView : ItemView {
+
+    public new ItemList<IOperator> Content {
+      get { return (ItemList<IOperator>)base.Content; }
+      set { base.Content = value; }
+    }
+
+    public OperatorTraceView() {
+      InitializeComponent();
+    }
+
+    protected override void DeregisterContentEvents() {
+      Content.CollectionReset -= Content_CollectionChanged;
+      Content.ItemsAdded -= Content_CollectionChanged;
+      Content.ItemsMoved -= Content_CollectionChanged;
+      Content.ItemsRemoved -= Content_CollectionChanged;
+      Content.ItemsReplaced -= Content_CollectionChanged;
+      base.DeregisterContentEvents();
+    }
+
+    protected override void RegisterContentEvents() {
+      base.RegisterContentEvents();
+      Content.CollectionReset += Content_CollectionChanged;
+      Content.ItemsAdded += Content_CollectionChanged;
+      Content.ItemsMoved += Content_CollectionChanged;
+      Content.ItemsRemoved += Content_CollectionChanged;
+      Content.ItemsReplaced += Content_CollectionChanged;
+    }
+
+    #region Event Handlers (Content)
+    void Content_CollectionChanged(object sender, CollectionItemsChangedEventArgs<Collections.IndexedItem<IOperator>> e) {
+      if (InvokeRequired)
+        Invoke(new EventHandler<CollectionItemsChangedEventArgs<IndexedItem<IOperator>>>(Content_CollectionChanged), sender, e);
+      else
+        UpdateOperatorTrace();
+    }
+    #endregion
+
+    private void UpdateOperatorTrace() {
+      listView.BeginUpdate();
+      listView.Items.Clear();
+      foreach (var item in Content) {
+        var viewItem = listView.Items.Add(item.Name ?? item.ItemName);
+        viewItem.Tag = item;
+      }
+      listView.EndUpdate();
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      if (Content == null) {
+        listView.Items.Clear();
+      } else {
+        UpdateOperatorTrace();
+      }
+    }
+
+    #region Event Handlers (child controls)
+    private void listView_ItemActivate(object sender, EventArgs e) {
+      if (listView.SelectedItems.Count > 0) {
+        IOperator op = listView.SelectedItems[0].Tag as IOperator;
+        if (op != null) {
+          MainFormManager.MainForm.ShowContent(op);
+        }
+      }
+    }
+    #endregion
+  }
+
+}
Index: /branches/HeuristicLab.DebugEngine/OperatorTraceView.resx
===================================================================
--- /branches/HeuristicLab.DebugEngine/OperatorTraceView.resx	(revision 4904)
+++ /branches/HeuristicLab.DebugEngine/OperatorTraceView.resx	(revision 4904)
@@ -0,0 +1,120 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<root>
+  <!-- 
+    Microsoft ResX Schema 
+    
+    Version 2.0
+    
+    The primary goals of this format is to allow a simple XML format 
+    that is mostly human readable. The generation and parsing of the 
+    various data types are done through the TypeConverter classes 
+    associated with the data types.
+    
+    Example:
+    
+    ... ado.net/XML headers & schema ...
+    <resheader name="resmimetype">text/microsoft-resx</resheader>
+    <resheader name="version">2.0</resheader>
+    <resheader name="reader">System.Resources.ResXResourceReader, System.Windows.Forms, ...</resheader>
+    <resheader name="writer">System.Resources.ResXResourceWriter, System.Windows.Forms, ...</resheader>
+    <data name="Name1"><value>this is my long string</value><comment>this is a comment</comment></data>
+    <data name="Color1" type="System.Drawing.Color, System.Drawing">Blue</data>
+    <data name="Bitmap1" mimetype="application/x-microsoft.net.object.binary.base64">
+        <value>[base64 mime encoded serialized .NET Framework object]</value>
+    </data>
+    <data name="Icon1" type="System.Drawing.Icon, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
+        <value>[base64 mime encoded string representing a byte array form of the .NET Framework object]</value>
+        <comment>This is a comment</comment>
+    </data>
+                
+    There are any number of "resheader" rows that contain simple 
+    name/value pairs.
+    
+    Each data row contains a name, and value. The row also contains a 
+    type or mimetype. Type corresponds to a .NET class that support 
+    text/value conversion through the TypeConverter architecture. 
+    Classes that don't support this are serialized and stored with the 
+    mimetype set.
+    
+    The mimetype is used for serialized objects, and tells the 
+    ResXResourceReader how to depersist the object. This is currently not 
+    extensible. For a given mimetype the value must be set accordingly:
+    
+    Note - application/x-microsoft.net.object.binary.base64 is the format 
+    that the ResXResourceWriter will generate, however the reader can 
+    read any of the formats listed below.
+    
+    mimetype: application/x-microsoft.net.object.binary.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Binary.BinaryFormatter
+            : and then encoded with base64 encoding.
+    
+    mimetype: application/x-microsoft.net.object.soap.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Soap.SoapFormatter
+            : and then encoded with base64 encoding.
+
+    mimetype: application/x-microsoft.net.object.bytearray.base64
+    value   : The object must be serialized into a byte array 
+            : using a System.ComponentModel.TypeConverter
+            : and then encoded with base64 encoding.
+    -->
+  <xsd:schema id="root" xmlns="" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
+    <xsd:import namespace="http://www.w3.org/XML/1998/namespace" />
+    <xsd:element name="root" msdata:IsDataSet="true">
+      <xsd:complexType>
+        <xsd:choice maxOccurs="unbounded">
+          <xsd:element name="metadata">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" />
+              </xsd:sequence>
+              <xsd:attribute name="name" use="required" type="xsd:string" />
+              <xsd:attribute name="type" type="xsd:string" />
+              <xsd:attribute name="mimetype" type="xsd:string" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="assembly">
+            <xsd:complexType>
+              <xsd:attribute name="alias" type="xsd:string" />
+              <xsd:attribute name="name" type="xsd:string" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="data">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+                <xsd:element name="comment" type="xsd:string" minOccurs="0" msdata:Ordinal="2" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" msdata:Ordinal="1" />
+              <xsd:attribute name="type" type="xsd:string" msdata:Ordinal="3" />
+              <xsd:attribute name="mimetype" type="xsd:string" msdata:Ordinal="4" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="resheader">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" />
+            </xsd:complexType>
+          </xsd:element>
+        </xsd:choice>
+      </xsd:complexType>
+    </xsd:element>
+  </xsd:schema>
+  <resheader name="resmimetype">
+    <value>text/microsoft-resx</value>
+  </resheader>
+  <resheader name="version">
+    <value>2.0</value>
+  </resheader>
+  <resheader name="reader">
+    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+  <resheader name="writer">
+    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+</root>