Index: branches/HeuristicLab.DebugEngine/DebugEngineView.Designer.cs
===================================================================
--- branches/HeuristicLab.DebugEngine/DebugEngineView.Designer.cs	(revision 4904)
+++ branches/HeuristicLab.DebugEngine/DebugEngineView.Designer.cs	(revision 4909)
@@ -47,74 +47,44 @@
       this.components = new System.ComponentModel.Container();
       System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(DebugEngineView));
-      this.label1 = new System.Windows.Forms.Label();
-      this.executionTimeTextBox = new System.Windows.Forms.TextBox();
-      this.operationContentView = new OperationContentView();
-      this.logView = new HeuristicLab.Core.Views.LogView();
-      this.splitContainer1 = new System.Windows.Forms.SplitContainer();
+      this.operationContentView = new HeuristicLab.DebugEngine.OperationContentView();
+      this.executionStackView = new HeuristicLab.DebugEngine.ExecutionStackView();
       this.splitContainer2 = new System.Windows.Forms.SplitContainer();
+      this.refreshButton = new System.Windows.Forms.Button();
+      this.skipStackOpsCheckBox = new System.Windows.Forms.CheckBox();
       this.stepButton = new System.Windows.Forms.Button();
       this.toolTip = new System.Windows.Forms.ToolTip(this.components);
-      this.refreshButton = new System.Windows.Forms.Button();
-      this.skipStackOpsCheckBox = new System.Windows.Forms.CheckBox();
       this.splitContainer3 = new System.Windows.Forms.SplitContainer();
-      this.executionStackView = new HeuristicLab.DebugEngine.ExecutionStackView();
-      this.operatorTraceView = new OperatorTraceView();
-      this.splitContainer1.Panel1.SuspendLayout();
-      this.splitContainer1.Panel2.SuspendLayout();
-      this.splitContainer1.SuspendLayout();
+      this.operatorTraceView = new HeuristicLab.DebugEngine.OperatorTraceView();
       this.splitContainer2.Panel1.SuspendLayout();
       this.splitContainer2.Panel2.SuspendLayout();
       this.splitContainer2.SuspendLayout();
       this.splitContainer3.Panel1.SuspendLayout();
+      this.splitContainer3.Panel2.SuspendLayout();
       this.splitContainer3.SuspendLayout();
       this.SuspendLayout();
       // 
-      // label1
-      // 
-      this.label1.AutoSize = true;
-      this.label1.Location = new System.Drawing.Point(3, 9);
-      this.label1.Name = "label1";
-      this.label1.Size = new System.Drawing.Size(83, 13);
-      this.label1.TabIndex = 0;
-      this.label1.Text = "Execution Time:";
-      // 
-      // executionTimeTextBox
-      // 
-      this.executionTimeTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+      // operationContentView
+      // 
+      this.operationContentView.Caption = "Operation Content View";
+      this.operationContentView.Content = null;
+      this.operationContentView.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.operationContentView.Location = new System.Drawing.Point(0, 0);
+      this.operationContentView.Name = "operationContentView";
+      this.operationContentView.ReadOnly = false;
+      this.operationContentView.Size = new System.Drawing.Size(484, 538);
+      this.operationContentView.TabIndex = 0;
+      // 
+      // executionStackView
+      // 
+      this.executionStackView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
-      this.executionTimeTextBox.Location = new System.Drawing.Point(92, 6);
-      this.executionTimeTextBox.Name = "executionTimeTextBox";
-      this.executionTimeTextBox.ReadOnly = true;
-      this.executionTimeTextBox.Size = new System.Drawing.Size(611, 20);
-      this.executionTimeTextBox.TabIndex = 1;
-      // 
-      // logView
-      // 
-      this.logView.Caption = "Log View";
-      this.logView.Content = null;
-      this.logView.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.logView.Location = new System.Drawing.Point(0, 0);
-      this.logView.Name = "logView";
-      this.logView.ReadOnly = false;
-      this.logView.Size = new System.Drawing.Size(198, 237);
-      this.logView.TabIndex = 2;
-      // 
-      // splitContainer1
-      // 
-      this.splitContainer1.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.splitContainer1.Location = new System.Drawing.Point(0, 0);
-      this.splitContainer1.Name = "splitContainer1";
-      this.splitContainer1.Orientation = System.Windows.Forms.Orientation.Horizontal;
-      // 
-      // splitContainer1.Panel1
-      // 
-      this.splitContainer1.Panel1.Controls.Add(this.executionStackView);
-      // 
-      // splitContainer1.Panel2
-      // 
-      this.splitContainer1.Panel2.Controls.Add(this.logView);
-      this.splitContainer1.Size = new System.Drawing.Size(198, 502);
-      this.splitContainer1.SplitterDistance = 261;
-      this.splitContainer1.TabIndex = 3;
+      this.executionStackView.Caption = "Execution Stack View";
+      this.executionStackView.Content = null;
+      this.executionStackView.Location = new System.Drawing.Point(0, 0);
+      this.executionStackView.Name = "executionStackView";
+      this.executionStackView.ReadOnly = false;
+      this.executionStackView.Size = new System.Drawing.Size(197, 505);
+      this.executionStackView.TabIndex = 0;
       // 
       // splitContainer2
@@ -126,18 +96,45 @@
       // splitContainer2.Panel1
       // 
-      this.splitContainer2.Panel1.Controls.Add(this.splitContainer1);
+      this.splitContainer2.Panel1.Controls.Add(this.executionStackView);
+      this.splitContainer2.Panel1.Controls.Add(this.refreshButton);
+      this.splitContainer2.Panel1.Controls.Add(this.skipStackOpsCheckBox);
+      this.splitContainer2.Panel1.Controls.Add(this.stepButton);
       // 
       // splitContainer2.Panel2
       // 
       this.splitContainer2.Panel2.Controls.Add(this.operationContentView);
-      this.splitContainer2.Size = new System.Drawing.Size(683, 502);
-      this.splitContainer2.SplitterDistance = 198;
+      this.splitContainer2.Size = new System.Drawing.Size(687, 538);
+      this.splitContainer2.SplitterDistance = 199;
       this.splitContainer2.TabIndex = 0;
       // 
+      // refreshButton
+      // 
+      this.refreshButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.refreshButton.Image = ((System.Drawing.Image)(resources.GetObject("refreshButton.Image")));
+      this.refreshButton.Location = new System.Drawing.Point(3, 511);
+      this.refreshButton.Name = "refreshButton";
+      this.refreshButton.Size = new System.Drawing.Size(24, 24);
+      this.refreshButton.TabIndex = 5;
+      this.toolTip.SetToolTip(this.refreshButton, "Refresh View");
+      this.refreshButton.UseVisualStyleBackColor = true;
+      this.refreshButton.Click += new System.EventHandler(this.refreshButton_Click);
+      // 
+      // skipStackOpsCheckBox
+      // 
+      this.skipStackOpsCheckBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.skipStackOpsCheckBox.AutoSize = true;
+      this.skipStackOpsCheckBox.Location = new System.Drawing.Point(63, 516);
+      this.skipStackOpsCheckBox.Name = "skipStackOpsCheckBox";
+      this.skipStackOpsCheckBox.Size = new System.Drawing.Size(78, 17);
+      this.skipStackOpsCheckBox.TabIndex = 6;
+      this.skipStackOpsCheckBox.Text = "Skip Stack";
+      this.toolTip.SetToolTip(this.skipStackOpsCheckBox, "Automatically step over steps that manipulate only the execution stack");
+      this.skipStackOpsCheckBox.UseVisualStyleBackColor = true;
+      // 
       // stepButton
       // 
-      this.stepButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.stepButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
       this.stepButton.Image = ((System.Drawing.Image)(resources.GetObject("stepButton.Image")));
-      this.stepButton.Location = new System.Drawing.Point(815, 3);
+      this.stepButton.Location = new System.Drawing.Point(33, 511);
       this.stepButton.Name = "stepButton";
       this.stepButton.Size = new System.Drawing.Size(24, 24);
@@ -147,26 +144,4 @@
       this.stepButton.Click += new System.EventHandler(this.stepButton_Click);
       // 
-      // refreshButton
-      // 
-      this.refreshButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
-      this.refreshButton.Image = ((System.Drawing.Image)(resources.GetObject("refreshButton.Image")));
-      this.refreshButton.Location = new System.Drawing.Point(845, 3);
-      this.refreshButton.Name = "refreshButton";
-      this.refreshButton.Size = new System.Drawing.Size(24, 24);
-      this.refreshButton.TabIndex = 5;
-      this.refreshButton.UseVisualStyleBackColor = true;
-      this.refreshButton.Click += new System.EventHandler(this.refreshButton_Click);
-      // 
-      // skipStackOpsCheckBox
-      // 
-      this.skipStackOpsCheckBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
-      this.skipStackOpsCheckBox.AutoSize = true;
-      this.skipStackOpsCheckBox.Location = new System.Drawing.Point(709, 8);
-      this.skipStackOpsCheckBox.Name = "skipStackOpsCheckBox";
-      this.skipStackOpsCheckBox.Size = new System.Drawing.Size(100, 17);
-      this.skipStackOpsCheckBox.TabIndex = 6;
-      this.skipStackOpsCheckBox.Text = "Skip Stack Ops";
-      this.skipStackOpsCheckBox.UseVisualStyleBackColor = true;
-      // 
       // splitContainer3
       // 
@@ -174,5 +149,5 @@
                   | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
-      this.splitContainer3.Location = new System.Drawing.Point(3, 33);
+      this.splitContainer3.Location = new System.Drawing.Point(0, 0);
       this.splitContainer3.Name = "splitContainer3";
       // 
@@ -180,31 +155,22 @@
       // 
       this.splitContainer3.Panel1.Controls.Add(this.splitContainer2);
+      // 
+      // splitContainer3.Panel2
+      // 
       this.splitContainer3.Panel2.Controls.Add(this.operatorTraceView);
-      this.splitContainer3.Size = new System.Drawing.Size(866, 502);
-      this.splitContainer3.SplitterDistance = 683;
+      this.splitContainer3.Size = new System.Drawing.Size(872, 538);
+      this.splitContainer3.SplitterDistance = 687;
       this.splitContainer3.TabIndex = 7;
+      // 
+      // operatorTraceView
+      // 
+      this.operatorTraceView.Caption = "Operator Trace View";
+      this.operatorTraceView.Content = null;
       this.operatorTraceView.Dock = System.Windows.Forms.DockStyle.Fill;
-      // 
-      // executionStackView
-      // 
-      this.executionStackView.Caption = "Execution Stack View";
-      this.executionStackView.Content = null;
-      this.executionStackView.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.executionStackView.Location = new System.Drawing.Point(0, 0);
-      this.executionStackView.Name = "executionStackView";
-      this.executionStackView.ReadOnly = false;
-      this.executionStackView.Size = new System.Drawing.Size(198, 261);
-      this.executionStackView.TabIndex = 0;
-      // 
-      // operationContentView
-      // 
-      this.operationContentView.Caption = "Operation Content View";
-      this.operationContentView.Content = null;
-      this.operationContentView.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.operationContentView.Location = new System.Drawing.Point(0, 0);
-      this.operationContentView.Name = "operationContentView";
-      this.operationContentView.ReadOnly = false;
-      this.operationContentView.Size = new System.Drawing.Size(481, 502);
-      this.operationContentView.TabIndex = 0;
+      this.operatorTraceView.Location = new System.Drawing.Point(0, 0);
+      this.operatorTraceView.Name = "operatorTraceView";
+      this.operatorTraceView.ReadOnly = false;
+      this.operatorTraceView.Size = new System.Drawing.Size(181, 538);
+      this.operatorTraceView.TabIndex = 0;
       // 
       // DebugEngineView
@@ -212,21 +178,14 @@
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.Controls.Add(this.splitContainer3);
-      this.Controls.Add(this.skipStackOpsCheckBox);
-      this.Controls.Add(this.refreshButton);
-      this.Controls.Add(this.stepButton);
-      this.Controls.Add(this.executionTimeTextBox);
-      this.Controls.Add(this.label1);
       this.Name = "DebugEngineView";
       this.Size = new System.Drawing.Size(872, 538);
-      this.splitContainer1.Panel1.ResumeLayout(false);
-      this.splitContainer1.Panel2.ResumeLayout(false);
-      this.splitContainer1.ResumeLayout(false);
       this.splitContainer2.Panel1.ResumeLayout(false);
+      this.splitContainer2.Panel1.PerformLayout();
       this.splitContainer2.Panel2.ResumeLayout(false);
       this.splitContainer2.ResumeLayout(false);
       this.splitContainer3.Panel1.ResumeLayout(false);
+      this.splitContainer3.Panel2.ResumeLayout(false);
       this.splitContainer3.ResumeLayout(false);
       this.ResumeLayout(false);
-      this.PerformLayout();
 
     }
@@ -234,8 +193,4 @@
     #endregion
 
-    private System.Windows.Forms.Label label1;
-    private System.Windows.Forms.TextBox executionTimeTextBox;
-    private Core.Views.LogView logView;
-    private System.Windows.Forms.SplitContainer splitContainer1;
     private System.Windows.Forms.SplitContainer splitContainer2;
     private System.Windows.Forms.Button stepButton;